//list of actions, that can be applied
var actionsDict = new Object();

function isBookHtmlLoaded()
{
	//return false if page.html is loaded alone
	if(window.parent == window)
		return false;
	return true;
}

function getObjectElement(elementId)
{
	var element = document.getElementById(elementId);
	if (isBookHtmlLoaded()) {
		return parent.$(element);
	}
	return $(element);
}

actionsDict["hideFrame"] = function(target, property)
{
	var targetElement = getObjectElement(target);
	targetElement.hide();
	if (document.getElementById(target + "content"))
	{
		targetElement = getObjectElement(target + "content");
		targetElement.hide();
	}
};

actionsDict["showFrame"] = function(target, property)
{
	var targetElement = getObjectElement(target);
	targetElement.show();
	if (document.getElementById(target + "content"))
	{
		targetElement = getObjectElement(target + "content");
		targetElement.show();
	}
};

actionsDict["toggleFrame"] = function(target, property){
	var targetElement = getObjectElement(target);
	targetElement.toggle();
	if (document.getElementById(target + "content"))
	{
		targetElement = getObjectElement(target + "content");
		targetElement.toggle();
	}
};

actionsDict["playMedia"] = function(target, property) 
{
	//playMedia(target+"media");
	sendPlayMediaViaNativeAppRequest(target +"media")
};

actionsDict["pauseMedia"] = function(target, property) 
{
	pauseMedia(target+"media");
};

actionsDict["stopMedia"] = function(target, property)
{
	stopMedia(target+"media");
};

actionsDict["rewindMedia"] = function(target, property) 
{
	var isPlaying = false;
	var element = document.getElementById(target + "media");
	if (!element.paused)
		isPlaying = true;
	stopMedia(target+"media");
	if (isPlaying) {
		//playMedia(target + "media");
		sendPlayMediaViaNativeAppRequest(target + "media");
	}
};

actionsDict["goToPreviousPage"] = function(target, property) {
	if (target == "this") {
		parent.goToPreviousPage();
	}
	else {
		document.getElementById(target+"content").contentWindow.goToPreviousPage(false);
	} 
};

actionsDict["goToNextPage"] = function(target, property) {
	if (target == "this") {
		parent.goToNextPage();
	}
	else {
		document.getElementById(target+"content").contentWindow.goToNextPage(false);
	} 
};

actionsDict["goToPage"] = function(target, property) {
	if (target == "this") {
		parent.goToPage(property);
	}
	else {
		document.getElementById(target+"content").contentWindow.goToPage(property, false);
	} 
};
	
actionsDict["openURL"] = function(target, property) {
	window.open(property);
};

actionsDict["playTimeline"] = function(target, property) {
	//if (target == "this")
		parent.setLifeCycleIsPlaying(true);
		parent.startLifeCycle("pageLifeCycle", target);
		/*if (parent.getBookAudio()!=null)
		{
			parent.getBookAudio().pause();
		}*/
	//else
		//startLifeCycle(target);
};

actionsDict["stopTimeline"] = function(target, property) {
	//if (target == "this")
		//stopLifeCycle("pageLifeCycle", target);
		parent.setLifeCycleIsPlaying(false);
		parent.stopLifeCycle("pageLifeCycle", target);
		parent.goToPage(1);
	//else
	//	stopLifeCycle(target); 
};

actionsDict["pauseTimeline"] = function(target, property) {
	//if (target == "this")
		parent.pauseLifeCycle("pageLifeCycle", target);
		parent.setLifeCycleIsPlaying(false);
		/*if (parent.getBookAudio()!=null)
		{
			parent.getBookAudio().pause();
		}*/
	//else
		//pauseLifeCycle(target);
};

actionsDict["rewindTimeline"] = function(target, property) {
	//if (target == "this")
		//rewindLifeCycle("pageLifeCycle", target);
		parent.goToPage(1);
	//else
		//rewindLifeCycle(target);
};


//list of event listeners
var eventsDict = new Object();


//add or remove pressed event listener
eventsDict["MOUSE_PRESSED"] = function(source, target, action, property, addEventHandler)
{
	//do nothing if element doesn't exist
	if(document.getElementById(source) == null)
		return;
		
	//mouse pressed handler
	function mousePressedHandler(event){
		//do not miss to execute stop propagation and prevent default to avoid browser from catching scrolling events or double tapping
		event.stopPropagation();
		event.preventDefault();
	
		getEventHandler(source, target, action, property);
	}
	
	if (parent.deviceChecker.android || parent.deviceChecker.iphone) {
		//we are running on android or ipad
		if(addEventHandler)
		{
			document.getElementById(source).addEventListener("touchstart",  mousePressedHandler, true);
		}
		else
		{
			document.getElementById(source).removeEventListener("touchstart",  mousePressedHandler, true);
		}
		
	}
	else { 
		var sourceElement = getObjectElement(source);
		//we are not running on android or ipad, add mouse down handler
		if(addEventHandler)
		{
			sourceElement.mousedown(mousePressedHandler);			
		}
		else
		{
			sourceElement.unbind('mousedown');
		}
		document.getElementById(source).style.cursor = "pointer";
	}
};

//add or remove mouse released event listener
eventsDict["MOUSE_RELEASED"] = function(source, target, action, property, addEventHandler)
{
	//do nothing if element doesn't exist
	if(document.getElementById(source) == null)
		return;
	
	//mouse released handler
	function mouseReleasedHandler(event)
	{
		getEventHandler(source, target, action, property);
		event.stopPropagation();
		event.preventDefault();
	}

	if (parent.deviceChecker.android || parent.deviceChecker.iphone) {
		//we are running on android or ipad
		if(addEventHandler)
		{
			document.getElementById(source).addEventListener("touchend", mouseReleasedHandler, true);
		}
		else
		{
			document.getElementById(source).removeEventListener("touchend", mouseReleasedHandler, true);
		}
	}
	else
	{
		var sourceElement = getObjectElement(source);
		//we are not running on android or ipad, add mouse down handler
		if(addEventHandler)
		{
			sourceElement.mouseup(mouseReleasedHandler);
		}
		else
		{
			sourceElement.unbind('mouseup');
		}
		document.getElementById(source).style.cursor = "pointer";
	} 
};

//add or remove mouse enter event listener
eventsDict["MOUSE_ENTER"] = function(source, target, action, property, addEventHandler)
{
	//do nothing if element doesn't exist
	if(document.getElementById(source) == null)
		return;
	
	//mouse enter handler
	function mouseEnterHandler(event)
	{	
		event.stopPropagation();
		getEventHandler(source, target, action, property);
	} 
 
	if (parent.deviceChecker.android || parent.deviceChecker.iphone) {
		//we are running on android or ipad
		if(addEventHandler)
		{
			document.getElementById(source).addEventListener("touchstart", mouseEnterHandler, true);
		}
		else
		{
			document.getElementById(source).removeEventListener("touchstart", mouseEnterHandler, true);
		}
	}
	else
	{
		var sourceElement = getObjectElement(source);
		//we are not running on android or ipad, add mouse down handler
		if(addEventHandler)
		{
			sourceElement.mouseover(mouseEnterHandler);
		}
		else
		{
			sourceElement.unbind('mouseover');
		}
	} 
};

//add or remove mouse leave event listener
eventsDict["MOUSE_LEAVE"] = function(source, target, action, property, addEventHandler)
{
	//do nothing if element doesn't exist
	if(document.getElementById(source) == null)
		return;
	
	//mouse leave handler
	function mouseLeaveHandler(event)
	{
		event.stopPropagation(); 
		getEventHandler(source, target, action, property);
	}
	
	if (parent.deviceChecker.android || parent.deviceChecker.iphone) {
		//we are running on android or ipad
		if (addEventHandler) {
			document.getElementById(source).addEventListener("touchend", mouseLeaveHandler, true);
		}
		else {
			document.getElementById(source).removeEventListener("touchend", mouseLeaveHandler, true);
		}
	}
	else {
		//we are running on PC
		var sourceElement = getObjectElement(source);
		if (addEventHandler) {
			sourceElement.mouseout(mouseLeaveHandler);
		}
		else {
			sourceElement.unbind('mouseout');
		}
	}
};

//add or remove mouse double click event listener
eventsDict["MOUSE_DOUBLE_CLICK"] = function(source, target, action, property, addEventHandler)
{
	//do nothing if element doesn't exist
	if(document.getElementById(source) == null)
		return;
	
	//mouse double click handler
	function mouseDoubleClickHandler(event)
	{ 
		event.stopPropagation(); 
		getEventHandler(source, target, action, property);
	}
	
	var sourceElement = getObjectElement(source);
	if(addEventHandler)
	{
		sourceElement.dblclick(mouseDoubleClickHandler);
	}
	else
	{
		sourceElement.unbind('dblclick');
	}
	document.getElementById(source).style.cursor = "pointer";
};

//add or remove frame shown event listener
eventsDict["FRAME_SHOWN"] = function(source, target, action, property, addEventHandler) 
{ 
	//frame shown handler
	function frameShownHandler(event)
	{
		if (event.data == source) {
			getEventHandler(source, target, action, property);
		}
	}
	
	if(addEventHandler)
	{
		parent.window.addEventListener("FRAME_SHOWN", frameShownHandler);
	}
	else
	{
		parent.window.removeEventListener("FRAME_SHOWN", frameShownHandler);
	}
};

//add or remove frame hidden event listener
eventsDict["FRAME_HIDDEN"] = function(source, target, action, property, addEventHandler) 
{
	//frame hidden handler
	function frameHiddenHandler(event)
	{
		if (event.data == source)
			getEventHandler(source, target, action, property);
	}
	
	if(addEventHandler)
	{
		parent.window.addEventListener("FRAME_HIDDEN", frameHiddenHandler);
	}
	else
	{
		parent.window.removeEventListener("FRAME_HIDDEN", frameHiddenHandler);
	}
};

//add or remove page shown event listener
eventsDict["PAGE_SHOWN"] = function(source, target, action, property, addEventHandler)
{
	//page shown handler
	function pageShownHandler(event)
	{
		event.stopPropagation();
		getEventHandler(source, target, action, property);
	}
	
	if(addEventHandler)
	{
		window.addEventListener("PAGE_SHOWN", pageShownHandler); 
	}
	else
	{
		window.removeEventListener("PAGE_SHOWN", pageShownHandler); 
	}
	
};

//add or remove page hidden event listener
eventsDict["PAGE_HIDDEN"] = function(source, target, action, property, addEventHandler)
{
	//page hidden handler
	function pageHiddenHandler(event)
	{
		event.stopPropagation();
		getEventHandler(source, target, action, property);
	}
	
	if(addEventHandler)
	{
		window.addEventListener("PAGE_HIDDEN", pageHiddenHandler);
	}
	else
	{
		window.removeEventListener("PAGE_HIDDEN", pageHiddenHandler);
	}
};


function getEventHandler(source, target, action, property)
{
	// Uncomment when link actions of the another page are added to sophie
	/*if (target.indexOf(".") != -1)
	{
		var targetPageNumber = target.substring(0, target.indexOf("."));
		var newTarget = target.substring(target.indexOf(".")+1, target.length);
		db.transaction(function(tx){
			tx.executeSql("SELECT * FROM SophieStateOfPages WHERE bookName=? AND pageId = ? AND target = ? AND action = ? AND property = ?", [parent.bookName, targetPageNumber , newTarget, action, property],
				function(tx, result) {
					if (result.rows.length > 0) 
						return;
					else {
						db.transaction(function(txx){
							txx.executeSql("INSERT INTO SophieStateOfPages (bookName, pageId, target, action, property) VALUES (?, ?, ?, ?, ?)", [parent.bookName, targetPageNumber, newTarget, action, property]);
						});
					}
            	});
			},
			function(tx, error) {
            	alert('Failed to retrieve sophie state from database - ' + error.message);
        });
	}
	else*/
		actionsDict[action](target, property);
}


var db = null;
var pageId;

try {
    if (window.openDatabase) {
        db = openDatabase("SophieDataBase", "1.0", "Sophie", 200000);
        if (!db)
            alert("Failed to open the database on disk.  This is probably because the version was bad or there is not enough space left in this domain's quota");
    } else
        alert("Couldn't open the database.  Please try with a WebKit nightly with this feature enabled");
} catch(err) {
    db = null;
    alert("Couldn't open the database.  Please try with a WebKit nightly with this feature enabled");
}

	
function loadedDatabase()
{
    db.transaction(function(tx) {
        tx.executeSql("SELECT COUNT(*) FROM SophieStateOfPages", [], function(result) {
            loadState();
        }, function(tx, error) {
            tx.executeSql("CREATE TABLE SophieStateOfPages (bookName TEXT, pageId TEXT, target TEXT, action TEXT, property TEXT)", [], function(result) { 
                loadState(); 
            });
        });
	
       
    });
}

function loadState()
{
    db.transaction(function(tx) {
        tx.executeSql("SELECT * FROM SophieStateOfPages WHERE bookName=? AND pageId = ?", [parent.bookName, pageId],
			function(tx, result) {
            for (var i = 0; i < result.rows.length; ++i) {
				var row = result.rows.item(i);
				//alert("target " + row.target + " action " + row.action + " property " + row.property);
				if(document.getElementById(row.target))
					actionsDict[row.action](row.target, row.property);
            }
        }, function(tx, error) {
            alert('Failed to retrieve sophie state from database - ' + error.message);
            return;
        });
    });
}