function addHtmlPrefixToUrlIfNotSpecified(browserSourceUrl){
	var lowerUrl = browserSourceUrl.toLowerCase();
	if(lowerUrl.substr(0, 7) == "http://"  || lowerUrl.substr(0, 8) == "https://"){
		return browserSourceUrl;
	}
	return "http://" + browserSourceUrl;
}

function buildBrowserInnerElement(data){

	var mainDiv = document.createElement("div");
	mainDiv.id = "main" + data.id;

	var browserWrapper = document.createElement("div");
	browserWrapper.id = "scroller" + data.id;
	var browserWrapperStyle = "position:absolute;"
	browserWrapperStyle += "width:" + data.width + "px;"
    browserWrapperStyle += " height:" + data.height + "px;"
	browserWrapperStyle += " overflow: auto;";
	browserWrapper.setAttribute("style", browserWrapperStyle);

	var element = document.createElement('iframe');
	var browserFrameStyle = "position:absolute;"
	browserFrameStyle += " width:" + data.width + "px;"
    browserFrameStyle += " height:" + data.height + "px;"
	browserFrameStyle += " overflow: auto;";
	element.setAttribute("style", browserFrameStyle);
	//element.className = "browserFrame";
	element.setAttribute('id', data.id);

	var browserSourceUrl = data.browser.source;
	//add http prefix if no prefix is defined
	browserSourceUrl = addHtmlPrefixToUrlIfNotSpecified(browserSourceUrl)

	element.setAttribute('src', browserSourceUrl);
	element.setAttribute('style', getContentStyle(data));
	element.width = "100%";
	element.height = "100%";
	element.style.visibility = "visible";
	element.style.display = "inline";
	element.style.scrolling = "auto";


	mainDiv.appendChild(browserWrapper);
	browserWrapper.appendChild(element);
	
	if (parent.deviceChecker.iphone) 
	{
		//for ipad with add top div which is used to scroll content of browser frame,
		//hand icons are added directly to browser frame wrapper because if we add them in transparent div the content below is unclickable
		//set top div style -> must be moved to external css file
		var topDivWithMoveIconsStyle = " position: absolute;";
	   	topDivWithMoveIconsStyle += " width:" + data.width + "px;"
	    topDivWithMoveIconsStyle += " height:" + data.height + "px;"
		topDivWithMoveIconsStyle += " overflow: auto;";
		topDivWithMoveIconsStyle += " background-color:rgba(0, 0, 0, 0.1);"
		//build top graied div that holds move icons
		var topDivWithMoveIcons = document.createElement("div");
		topDivWithMoveIcons.id = "topDivWithMoveIcon" + data.id;
		topDivWithMoveIcons.className = "browserScroller";
		topDivWithMoveIcons.setAttribute('style', topDivWithMoveIconsStyle);
		//add move icon to all four corners of greied div
		//add top left hand icon
		var topLeftIcon = document.createElement("image");
		topLeftIcon.src = "../system/browser/icnMove.png";
		topLeftIcon.setAttribute("style", "position:fixed; left:3px; top:3px;");
		topDivWithMoveIcons.appendChild(topLeftIcon);	
		//add top right hand icon
		var topRightIcon = document.createElement("image");
		topRightIcon.src = "../system/browser/icnMove.png";
		topRightIcon.setAttribute("style", "position:fixed; right:3px; top:3px;");
		topDivWithMoveIcons.appendChild(topRightIcon);
		//add bottom left hand icon
		var bottomLeftIcon = document.createElement("image");
		bottomLeftIcon.src = "../system/browser/icnMove.png";
		bottomLeftIcon.setAttribute("style", "position:fixed; left:3px; bottom:3px;");
		topDivWithMoveIcons.appendChild(bottomLeftIcon);
		//add bottom right hand icon
		var bottomRightIcon = document.createElement("image");
		bottomRightIcon.src = "../system/browser/icnMove.png";
		bottomRightIcon.setAttribute("style", "position:fixed; right:3px; bottom:3px;");
		topDivWithMoveIcons.appendChild(bottomRightIcon);
		
		//add hand icon to all four corners of wrapper div
		//add top left hand icon
		var topLeftHandIcon = document.createElement("image");
		topLeftHandIcon.id = "topLeftHandIcon" + data.id;
		topLeftHandIcon.src = "../system/browser/icnHand.png";
		topLeftHandIcon.setAttribute("style", "position:fixed; left:3px; top:3px; visibility:hidden");
		mainDiv.appendChild(topLeftHandIcon);	
		//add top right hand icon
		var topRightHandIcon = document.createElement("image");
		topRightHandIcon.id = "topRightHandIcon" + data.id;
		topRightHandIcon.src = "../system/browser/icnHand.png";
		topRightHandIcon.setAttribute("style", "position:fixed; right:3px; top:3px; visibility:hidden");
		mainDiv.appendChild(topRightHandIcon);
		//add bottom left hand icon
		var bottomLeftHandIcon = document.createElement("image");
		bottomLeftHandIcon.id = "bottomLeftHandIcon" + data.id;
		bottomLeftHandIcon.src = "../system/browser/icnHand.png";
		bottomLeftHandIcon.setAttribute("style", "position:fixed; left:3px; bottom:3px; visibility:hidden");
		mainDiv.appendChild(bottomLeftHandIcon);
		//add bottom right hand icon
		var bottomRightHandIcon = document.createElement("image");
		bottomRightHandIcon.id = "bottomRightHandIcon" + data.id;
		bottomRightHandIcon.src = "../system/browser/icnHand.png";
		bottomRightHandIcon.setAttribute("style", "position:fixed; right:3px; bottom:3px;  visibility:hidden");
		mainDiv.appendChild(bottomRightHandIcon);
		
		mainDiv.appendChild(topDivWithMoveIcons);
	
	}
	
	return mainDiv;
}

//Used to add scroll div used to navigate in browser frame content on iPad
function onLoadMainBrowserFrameDiv(data)
{
	var startY = 0;
	var startX = 0;
	var topElementWithMoveIcon = document.getElementById("topDivWithMoveIcon" + data.id);
	var topLeftHandIcon = document.getElementById("topLeftHandIcon" + data.id);
	var topRightHandIcon = document.getElementById("topRightHandIcon" + data.id);
	var bottomLeftHandIcon = document.getElementById("bottomLeftHandIcon" + data.id);
	var bottomRightHandIcon = document.getElementById("bottomRightHandIcon" + data.id);
	

	function onClick(event)
	{
		topElementWithMoveIcon.style.visibility = "hidden";
		topLeftHandIcon.style.visibility = "visible";
		topRightHandIcon.style.visibility = "visible";
		bottomLeftHandIcon.style.visibility = "visible";
		bottomRightHandIcon.style.visibility = "visible";
		
		
		setTimeout(
			function(){
				topElementWithMoveIcon.style.visibility = "visible";
				topLeftHandIcon.style.visibility = "hidden";
				topRightHandIcon.style.visibility = "hidden";
				bottomLeftHandIcon.style.visibility = "hidden";
				bottomRightHandIcon.style.visibility = "hidden";
			}, 5000);
	}

	topElementWithMoveIcon.addEventListener('click', onClick);

	topElementWithMoveIcon.addEventListener('touchstart', function (event) {
		parent.window.scrollTo(0, 1);
		startY = event.targetTouches[0].pageY;
		startX = event.targetTouches[0].pageX;
	});

	topElementWithMoveIcon.addEventListener('touchmove', function (event) {
		event.preventDefault();
		if (event.stopPropagation) {
			event.stopPropagation();
		} else {
			event.cancelBubble = true;
		}
		var posy = event.targetTouches[0].pageY;
		var h = document.getElementById("scroller" + data.id);
		var sty = h.scrollTop;

		var posx = event.targetTouches[0].pageX;
		var stx = h.scrollLeft;

		h.scrollTop = sty - (posy - startY);
		h.scrollLeft = stx - (posx - startX);
		startY = posy;
		startX = posx;
	});

}

