//get user agent to detect device witch is used
var ua = navigator.userAgent.toLowerCase();
var deviceChecker = {
  iphone: ua.match(/(iphone|ipod|ipad)/),
  android: ua.match(/android/),
  safari: ua.match(/safari/)
};

var currentPageNumber = 0;
var currentPageFrameId = "frame0";
var pagesCount = 0;

//count of preloaded frames
var framesCount = 6;
//used to store page number of preloaded frames
var leftMost, rightMost;

var bookId = "";

var isSophiePreview = false;
var isEmbedded = false;

var currentBookScaleFactorX = 1;
var currentBookScaleFactorY = 1;

//indicate is content of iframe is loaded yet
var iframeContentLoaded;

//help function used in preloading
function getGroupSize()
{
	return parseInt(framesCount/3);
}

var pages;
var pageIds;
var postfix = "";
var bookName;
var lifeCycleIsPlaying = true;

var bookWidth = 0;
var bookHeight = 0;

//here book json is readed		
function loadBookJSON(fname) 
{
	$.getJSON(fname, function(data) {
		buildBook(data);
	});
}

/**
 * Entry point for building book functionality.
 * @param {Object} data - json of the book.
 */
function buildBook(data){
	if (!deviceChecker.safari) { // Book is opened from the native ipad application
		removeBottomToolbar();
		framesCount = 3;
	}
	
	var locale = new String(window.location);
	var width;
	var height;
	if (locale.indexOf("?")!=-1) {
		postfix = locale.substring(locale.indexOf("?"), locale.length);
		var indexOfFirstAmperson = postfix.indexOf("&", postfix.indexOf("currentPage="));
		if (indexOfFirstAmperson != -1)
			isEmbedded = true;
		if (!isEmbedded)
		{
			isSophiePreview = true;
			currentPageNumber = parseInt(postfix.substring(postfix.indexOf("currentPage=")+12, postfix.length)) - 1;
			width = parseInt(data.width);
			height = parseInt(data.height);
		}
		else
		{
			currentPageNumber = parseInt(postfix.substring(postfix.indexOf("currentPage=")+12, indexOfFirstAmperson)) - 1;
			var widthIFrame = postfix.substring(postfix.indexOf("widthIFrame=")+12, postfix.indexOf("&", postfix.indexOf("widthIFrame=")));
			var heightIFrame = postfix.substring(postfix.indexOf("heightIFrame=")+13, postfix.indexOf("&", postfix.indexOf("heightIFrame=")));
			width = widthIFrame;
			height = heightIFrame;
			postfix = postfix.substring(postfix.indexOf("width="), postfix.length);
			framesCount = 3;
		}
	}
	else {
		width = parseInt(data.width);
		height = parseInt(data.height);
	}
	
   	document.title = data.title;
	bookName = data.title;
	bookId = data.bookId;
   	pagesCount = data.pages.length;
	
	bookWidth = data.width;
	bookHeight = data.height;
	
	if (isEmbedded)
		document.body.style.background = "rgba(0, 0, 0, 0)";
	
	//calculate scale factor
	if (!isEmbedded && !deviceChecker.android && !deviceChecker.iphone)
	{
		currentBookScaleFactorX = 1;
		currentBookScaleFactorY = 1;
	}
	else if (!isEmbedded)
	{
		var scaleW = window.innerWidth / bookWidth;
		var scaleH = window.innerHeight / bookHeight;
		var scaleFactor = Math.min(scaleW, scaleH, 1);
		currentBookScaleFactorX = scaleFactor;
		currentBookScaleFactorY = scaleFactor;
	}
	else
	{
		currentBookScaleFactorX = parent.currentPageScaleFactorX;
		currentBookScaleFactorY = parent.currentPageScaleFactorY;
	}
	
	//console.log("pagesCount=" + pagesCount);
   	
	if(framesCount > pagesCount)
		framesCount = pagesCount;
		
	//calculate left value that will be used to center frames on desktop browsers
	var newLeftForDesktopBrowsers = 0;
	if (!isEmbedded)
		newLeftForDesktopBrowsers = (window.innerWidth - bookWidth)/2;


	var frameIndex = 0;
	for(frameIndex = 0; frameIndex < framesCount; frameIndex++)
	{
		document.getElementById("frame" + frameIndex).width = width * currentBookScaleFactorX;
		document.getElementById("frame" + frameIndex).height = height * currentBookScaleFactorY;
		
		//center frames on desktop browsers
		if((currentBookScaleFactorX == 1 && currentBookScaleFactorY == 1) ||
			(!deviceChecker.iphone && !deviceChecker.android))
		{
			document.getElementById("frame" + frameIndex).style.left = newLeftForDesktopBrowsers;
		}
		else
		{
			document.getElementById("frame" + frameIndex).className += " noMarginsForOtherDevices";
		}
		
	}
	
	pages = new Array(pagesCount);
	pageIds = new Array(pagesCount);
   	if (data.pages != null){
		for (var i = 0; i < data.pages.length; i++) {
			if (postfix != "") {
				pages[i] = data.pages[i].url + "?" + postfix;
			}
			else {
				pages[i] = data.pages[i].url;
			}
			pageIds[i] = data.pages[i].id;
			thumbnails[i] = data.pages[i].thumbnail;
   		}
   	}
	
	if (!isEmbedded)
		buildThumbnailExplorer(pagesCount, width, height);
	else
		removeBottomToolbar();
	
	if (!isEmbedded && !isSophiePreview)
		currentPageNumber = getPageToBeShownOnOpening();
	else if (!isSophiePreview)
		currentPageNumber = 0;
		
		
	iframeContentLoaded = new Array(framesCount);
	for (var i = 0; i < framesCount; i++)
		iframeContentLoaded[i] = false;
		
	setIFrameContent("frame" + (currentPageNumber % framesCount), bookName,
				currentPageNumber+1, getClassNameForFrame(currentPageNumber, currentPageNumber, !isEmbedded));
	iframeContentLoaded[currentPageNumber % framesCount] = true;
	
	setCurrentThumb(currentPageNumber, -1);

	document.getElementById("frame" + currentPageNumber%framesCount).style.visibility = "visible";
	
	if (!isEmbedded) {
		document.getElementById("frame" + currentPageNumber%framesCount).setAttribute("onload", "onFirstPageLoaded(event)");
	}
				
	$(document).keydown(function(event)
	{
		var code = (event.keyCode ? event.keyCode : event.which);
		// handle cursor keys
		if (code == 37) { //<-
			// navigate to the previous page
			tryToGoToPreviousPage();
		}
		else if (code == 39) { //->
			// navigate to the next page
			tryToGoToNextPage();
		}
	});
	
	if (data.lifeCycle != null)
		buildBookLifeCycle(data);
		
	if (data.audio != null)
		buildBookAudio(data.audio);
		
		
	var supportsOrientationChange = "onorientationchange" in window;
    var orientationEvent = supportsOrientationChange ?
							"orientationchange" : "resize";
	
	//add resize and center listener for Ipad
	if (deviceChecker.iphone){
		window.addEventListener(orientationEvent, function(){
			if (!isEmbedded) {
				//fit book to screen on orientation change
				fitBookToScreen();
				centerAddCommentDialog();
				centerAboutSophieDialog();
				resizeThumbnailExplorer();
			}
		});
		//methods are called ot init to center book if necessary
		if (!isEmbedded) {
			//center book on load
			centerPageFrameOnResizeOnDesktopBrowsers();
			centerAddCommentDialog();
			centerAboutSophieDialog();
		}
	}
	
	//add resize and center listener for Android
	if (deviceChecker.android){
		window.addEventListener(orientationEvent, function(){
			window.addEventListener("resize", function(event){
				resized(event);
				resizeThumbnailExplorer();
			});
		});
		//center add comment dialog on every resize because keyboard appears over html book
		window.addEventListener("resize", function(event){
			centerAddCommentDialog();
		});
	}
	
	//add resize and center listener for Desktop browser
	if(!deviceChecker.iphone && !deviceChecker.android)
	{
		window.addEventListener("resize", function(event){
			centerPageFrameOnResizeOnDesktopBrowsers(event);
			centerAddCommentDialog();
			centerAboutSophieDialog();
		});
		//book is centered when loaded
		centerPageFrameOnResizeOnDesktopBrowsers(event);
		centerAddCommentDialog();
		centerAboutSophieDialog();
	}
		
}

/**
 * Listener for resize event for centering page on desktop browsers. * 
 */
function centerPageFrameOnResizeOnDesktopBrowsers(event){
	if (isEmbedded)
		return;
	//calculate new left position	
	var newLeft = ((window.innerWidth - bookWidth*currentBookScaleFactorX) / 2);
	if(newLeft < 0)
		newLeft = 0;
	newLeft = newLeft + "px";
	//calculate new top position
	var newTop = ((window.innerHeight - bookHeight*currentBookScaleFactorY) / 2);
	if(newTop < 0)
		newTop = 0;
	newTop = newTop + "px";
	//do nothing if new left is equal to old one to prevent auto refresh issues
	if(newLeft != document.getElementById(getCurrentPageFrameId()).style.left)
		document.getElementById(getCurrentPageFrameId()).style.left = newLeft;
	if(newTop != document.getElementById(getCurrentPageFrameId()).style.top)
		document.getElementById(getCurrentPageFrameId()).style.top = newTop;
	//scroll window to upper left corner
	window.scrollTo(0, 0);	
}

/**
 * Function that center add new comment dialog
 */
function centerAddCommentDialog(){
	var newLeft = ((window.innerWidth - document.getElementById("commentDialog").offsetWidth) / 2) + "px";
	var newTop = ((window.innerHeight - document.getElementById("commentDialog").offsetHeight) / 2) + "px";
	if(newLeft != document.getElementById("commentDialog").offsetWidth || newTop != document.getElementById("commentDialog").offsetWidth)
	{
		document.getElementById("commentDialog").style.left = newLeft;
		document.getElementById("commentDialog").style.top = newTop; 
	}
}

/**
 * Function that center about sophie project dialog
 */
function centerAboutSophieDialog(){
	var newLeft = ((window.innerWidth - document.getElementById("aboutSophieDialog").offsetWidth) / 2) + "px";
	var newTop = ((window.innerHeight - document.getElementById("aboutSophieDialog").offsetHeight) / 2) + "px";
	if(newLeft != document.getElementById("aboutSophieDialog").offsetWidth || newTop != document.getElementById("aboutSophieDialog").offsetWidth)
	{
		document.getElementById("aboutSophieDialog").style.left = newLeft;
		document.getElementById("aboutSophieDialog").style.top = newTop; 
	}
}

/**
 * Listener for resize event for fitting page into the window. Used only for android.
 * @param {Object} event - resize event.
 */
function resized(event)
{
	event.stopPropagation();
	parent.window.removeEventListener("resize", resized);
	if (!isEmbedded)
		fitBookToScreen();
}	

/**
 * Retrieves page on which book should be opened. If book has stored page, retrieves it.
 * Otherwise - retrieves 0.
 */
function getPageToBeShownOnOpening()
{
	if (!localStorage.getItem(bookId))
		return 0;
	var pageIndex = localStorage.getItem(bookId);
	if (pageIndex > pagesCount)
		return pagesCount - 1;
	return parseInt(pageIndex);
}
  
/**
 * First page after opening of the book is loded and it can be setted as current.
 * @param {Object} event - loaded event.
 */
function onFirstPageLoaded(event)
{
	if (event)
		event.stopPropagation();
	var currentFrameId = "frame" + currentPageNumber%framesCount;
	setTimeout(function(){setCurrentPage(currentPageNumber)}, 1500);
	document.getElementById(currentFrameId).setAttribute("onload", null);
	document.getElementById(currentFrameId).className = "current"
}
  
/**
 * Function for triggering playing of the lifecycle outro or going to the next page.
 */
function tryToGoToNextPage()
{
//	if (document.getElementById(currentPageFrameId).contentWindow.isInOutro())
	goToNextPage();
//else {
  //  document.getElementById(currentPageFrameId).contentWindow.goToOtroOfPage(true);
//}
}
  
/**
 * Function for triggering playing of the lifecycle outro or going to the previous page.
 */
function tryToGoToPreviousPage()
{
	//if (document.getElementById(currentPageFrameId).contentWindow.isInOutro())
	goToPreviousPage();
//else {
  //  document.getElementById(currentPageFrameId).contentWindow.goToOtroOfPage(false);
//}
}
 
//variable used to indicated whether transition effect executed on go to next/prev page is running
var runningEffect = false; 

/**
 * Preloads pages after current if this is necessary.
 */
function preloadNextPagesIfNecessary()
{
	var groupSize = getGroupSize();
	if(rightMost + groupSize > pagesCount)
	{
		groupSize = pagesCount - rightMost;
	}
	//we reach all preloaded page, preload next if exist
	//if we are less than two pages from end of the group preload next 	
	if((rightMost - currentPageNumber < groupSize)  && (rightMost+groupSize) <= pagesCount)
	{
		//console.log("DEBUG : override last " + groupSize + " pages")
		var index = 0;
		for(index=1; index<=groupSize; index++)
		{
			setIFrameContent("frame" + ((rightMost+index)%framesCount), bookName, rightMost+index+1, "next");
		}
		//shift groups right 
		leftMost += groupSize;
		rightMost += groupSize;				
	}		
}

//
/**
 * Go to next page, transition page effect is running here via css-transform.
 * @param {Object} shouldAnimate - flag for animation.
 */
function goToNextPage(shouldAnimate)
{
	if (shouldAnimate == null)
		shouldAnimate = true;
	if (currentPageNumber == pagesCount-1 ||
		iframeContentLoaded[(currentPageNumber + 1) % framesCount] == false)
	{
		return;
	}  
	else if(runningEffect)
	{
		//setTimeout( function(){	runningEffect = false;	},	500 );
		return;
	}
		
	runningEffect = true;
	
	setCurrentThumb(currentPageNumber+1, currentPageNumber);
	
	currentPageNumber++;
	currentPageFrameId = "frame" + (currentPageNumber%framesCount);
	
	//decrease z-index of current visible iframe to enable move transition to be over visible iframe, because its style is changed after transition effect completes
	if (shouldAnimate)
		$("#frame" + ((currentPageNumber-1)%framesCount) ).addClass("moveFrameBehind");
	
	
	//var nextPageFrame = document.getElementById(nextPageFrameId);
	var nextPageFrame = document.getElementById(currentPageFrameId);
	nextPageFrame.style.visibility = "visible";
	if (shouldAnimate)
		nextPageFrame.className = "current";
	else
		nextPageFrame.className = "currentWithoutAnimation";
	
	//var currentPageFrame = document.getElementById("frame" + currentPageFrameId); 
	var lastCurrentPageFrameId = "frame" + ((currentPageNumber-1)%framesCount);
	var lastCurrentPageFrame = document.getElementById(lastCurrentPageFrameId);
	
	//check function for existence before executing it to prevent error
	if(lastCurrentPageFrame.contentWindow.onNotCurrentPage != null)
		lastCurrentPageFrame.contentWindow.onNotCurrentPage(pageIds[currentPageNumber-1]);
	 
	//if current page is first of preloaded then preload left pages
	preloadNextPagesIfNecessary();
	
	if (lastCurrentPageFrameId != currentPageFrameId) {
		//wait for transition page effect to complete to hide last currentPageFrame
		setTimeout(function(){
			lastCurrentPageFrame.style.visibility = "hidden";
			lastCurrentPageFrame.className = "previous";
			runningEffect = false
		}, 500);
	}
	else
	{
		setIFrameContent(currentPageFrameId, bookName, currentPageNumber + 1, "current");
		runningEffect = false;
	}
	
	//console.log("goToNext, currentPageNumber = " + currentPageNumber);
	setCurrentPage(currentPageNumber);
}


//
/**
 * Return class name for frame with given index and current frame number.
 * @param {Object} index - index of the iframe.
 * @param {Object} currentFrameNumber - number of the current page.
 * @param {Object} shouldAnimate - flag for animation.
 */
function getClassNameForFrame(index, currentFrameNumber, shouldAnimate)
{
	if (shouldAnimate == null)
		shouldAnimate = true;
	var className = "previous";
	if (index == currentFrameNumber) {
		if (shouldAnimate)
			className = "current";
		else
			className = "currentWithoutAnimation";
	}
	if (index > currentFrameNumber) 
		className = "next";
	return className;
}

/**
 * Preloads pages around current.
 * @param {Object} pageNumber - current page numbed (0 based).
 * @param {Object} shouldAnimate - flag for animation.
 */
function preloadAllPagesAround(pageNumber, shouldAnimate)
{
	//pageNumber++;
	//there are no useful pages in the memory, override whole preloading array
	var leftPreloaded = parseInt(framesCount / 2);
	var rightPreloaded = framesCount - leftPreloaded - 1;
	//ensure that leftPreloaded + rightPreloaded is equal to framesCount
	
	leftMost = pageNumber - leftPreloaded;
	rightMost = pageNumber + rightPreloaded;
	
	if (leftMost < 0) {
		rightMost += -leftMost;
		leftMost = 0;
	}
	else if (rightMost >= pagesCount-1) 
	{
		leftMost -= rightMost - (pagesCount-1);
		rightMost = pagesCount-1;
	}
	
	for (index = pageNumber + 1; index <= rightMost; index++)
	{
		setIFrameContent("frame" + (index % framesCount), bookName, index+1, getClassNameForFrame(index, pageNumber, shouldAnimate));
	}
	for (index = pageNumber - 1; index >= leftMost; index--)
	{ 
		setIFrameContent("frame" + (index % framesCount), bookName, index+1, getClassNameForFrame(index, pageNumber, shouldAnimate));
	}
	var pageFrame = document.getElementById("frame" + (pageNumber%framesCount) );
	pageFrame.style.visibility = "visible";
	
	if (parent!=this) {
		parent.embeddedBookBuilt();
	}
	
}

/**
 * Preloads pages before current if this is necessary.
 */
function preloadPreviousPagesIfNecessary()
{
	var groupSize = getGroupSize();
	if(leftMost - groupSize < 0)
		groupSize = leftMost;
		
	if (currentPageNumber == leftMost && (leftMost-groupSize)>=0) {
		//console.log("preload left group");
		var index = 0;
		for(index=1; index<=groupSize; index++)
		{
			//console.log("preload frame"+ ((leftMost-index)%framesCount));
			setIFrameContent("frame"+ ((leftMost-index)%framesCount), bookName, leftMost-index+1, "previous");
		}
		//shift groups left 
		leftMost -= groupSize;
		rightMost -= groupSize;
	}
}

/**
 * Go to previous page, transition page effect is running here via css-transform.
 * @param {Object} shouldAnimate - flag for effect.
 */
function goToPreviousPage(shouldAnimate)
{
	if (shouldAnimate == null)
		shouldAnimate = true;
	if(currentPageNumber == 0 || iframeContentLoaded[(currentPageNumber - 1) % framesCount] == false)
	{
	   return;
	}
	else if(runningEffect)
	{
		//setTimeout( function(){	runningEffect = false; },	500 );
		return;
	}
	runningEffect = true;
	
	setCurrentThumb(currentPageNumber-1, currentPageNumber);
	
	currentPageNumber--;
	currentPageFrameId = "frame" + (currentPageNumber%framesCount);
	
	//decrease z-index of current visible iframe to enable move transition to be over visible iframe, because its style is changed after transition effect completes
	if (shouldAnimate)
		$("#frame" + ((currentPageNumber+1)%framesCount) ).addClass("moveFrameBehind");
	
	//get previous page frame and run animated transition effect
	var previousPageFrame = document.getElementById(currentPageFrameId);
	previousPageFrame.style.visibility = "visible";
	if (shouldAnimate)
		previousPageFrame.className = "current";
	else
		previousPageFrame.className = "currentWithoutAnimation";
	
	var lastCurrentPageFrameId = "frame" + ((currentPageNumber+1)%framesCount);
	var lastCurrentPageFrame = document.getElementById(lastCurrentPageFrameId); 
	
	//check function for existence before executing it to prevent error
	if(lastCurrentPageFrame.contentWindow.onNotCurrentPage != null)
		lastCurrentPageFrame.contentWindow.onNotCurrentPage(pageIds[currentPageNumber+1]);
	
	//if current page is first of preloaded then preload previous pages
	preloadPreviousPagesIfNecessary();
	
	if (lastCurrentPageFrameId != currentPageFrameId) {
		//wait for transition page effect to complete to hide last currentPageFrame
		setTimeout(function(){
			lastCurrentPageFrame.style.visibility = "hidden";
			lastCurrentPageFrame.className = "next";
			//not that last currentPageFrameId not is nextPageFrameId
			$("#frame" + ((currentPageNumber + 1) % framesCount)).removeClass("moveFrameBehind");
			runningEffect = false;
			
		}, 500);
	}
	else
	{
		setIFrameContent(currentPageFrameId, bookName, currentPageNumber + 1, "current");
		runningEffect = false;
	}
	
	//console.log("goToPrevious, currentPageNumber = " + currentPageNumber);
	setCurrentPage(currentPageNumber);
}
  
/**
 * Updates position of the page in the iframe towards current page.
 * @param {Object} pageNumber - number of the page.
 * @param {Object} shouldAnimate - flag for animation.
 */
function updateClassNameForAllFrames(pageNumber, shouldAnimate)
{
	for (var index = leftMost; index <= rightMost; index++) {
		document.getElementById("frame" + (index % framesCount)).className = getClassNameForFrame(index, pageNumber, shouldAnimate);
	}
}  
 
/**
 * Function for jumping to page with page number.
 * 
 * @param {Object} pageNumber - page number of the page on which user wants to go (1-based)
 * @param {Object} shouldAnimate - flag whenever should swipe to page with or without animation
 */ 
function goToPage(pageNumber, shouldAnimate)
{
	if (shouldAnimate == null)
		shouldAnimate = true;
	
	//console.log("goToPage " + pageNumber);
	
	var lastCurrentPageFrameId = "frame" + (currentPageNumber%framesCount);
	pageNumber = pageNumber-1;
	
	if (pageNumber == currentPageNumber) 
	{
  		if (lifeCycleIsPlaying) 
//  			document.getElementById(currentPageFrameId).contentWindow.rewindLifeCycle("pageLifeCycle", pageIds[currentPageNumber - 1])
  		return;
  	}
	
	setCurrentThumb(pageNumber, currentPageNumber);
	
	document.getElementById(lastCurrentPageFrameId).style.visibility = "hidden";
	document.getElementById(lastCurrentPageFrameId).className = getClassNameForFrame(currentPageNumber, pageNumber, shouldAnimate);
	
	//check function for existence before executing it po prevent error 
	if(document.getElementById(lastCurrentPageFrameId).contentWindow.onNotCurrentPage != null)
		document.getElementById(lastCurrentPageFrameId).contentWindow.onNotCurrentPage(pageIds[currentPageNumber]);
	
	console.log("curpage "+currentPageNumber);
  	
	currentPageNumber = pageNumber;	
	currentPageFrameId = "frame" + (currentPageNumber%framesCount);
	
	var index;
	//if page is already loaded, do not preload anything
	if (leftMost <= pageNumber && pageNumber <= rightMost) {
		
		updateClassNameForAllFrames(pageNumber, shouldAnimate);
		document.getElementById(currentPageFrameId).style.visibility = "visible";
		//if page is in the end of list of preloaded pages then load its neighbours
		preloadPreviousPagesIfNecessary();
		preloadNextPagesIfNecessary();
		setCurrentPage(pageNumber);
		return ;
	}
	
	//check whether we can use some of preloaded pages
	if((pageNumber < leftMost) && (leftMost-pageNumber) < (framesCount - getGroupSize()))
	{
		for(index=pageNumber; index<leftMost; index++)
		{
			setIFrameContent("frame" + (index%framesCount), bookName, index+1, getClassNameForFrame(index, pageNumber, shouldAnimate));
		}
		
		
		updateClassNameForAllFrames(pageNumber, shouldAnimate);
		leftMost = pageNumber;
		rightMost = leftMost + framesCount - 1;
		
		preloadPreviousPagesIfNecessary();
		
		document.getElementById(currentPageFrameId).style.visibility = "visible";
		
		setTimeout(function(){setCurrentPage(pageNumber)}, 1500);
		return ;
	}
	
	if (pageNumber > rightMost && (pageNumber - rightMost) < (framesCount - getGroupSize())) 
	{
		
		for(index=rightMost+1; index<=pageNumber; index++)
		{
			setIFrameContent("frame" + (index%framesCount), bookName, index+1, getClassNameForFrame(index, pageNumber, shouldAnimate));
		}
		
		rightMost = pageNumber;
		leftMost = rightMost - framesCount + 1 
		
		preloadNextPagesIfNecessary();
		
		updateClassNameForAllFrames(pageNumber, shouldAnimate);
		document.getElementById(currentPageFrameId).style.visibility = "visible";
		setTimeout(function(){setCurrentPage(pageNumber)}, 1500);
	
		return ;
	}
	
	if (!shouldAnimate) {
		for (var i = 0; i < framesCount; i++) {
			cleanContent("frame" + i);
			document.getElementById("frame" + i).src = "";
		}
	}
	//preloaded page are useful preload all pages
	currentPageNumber = pageNumber;
	setIFrameContent("frame" + (pageNumber % framesCount), bookName,
				pageNumber+1, getClassNameForFrame(pageNumber, pageNumber, shouldAnimate));
				
	setTimeout(function(){setCurrentPage(pageNumber)}, 1500);
	//preloadAllPagesAround(pageNumber, shouldAnimate);
	return ;	
}
  
/**
 * Setter for the content of the iframe with all necessary information of the page.
 * @param {Object} iframeId - id of the iframe that will be contain the page.
 * @param {Object} nameOfBook - name of the book.
 * @param {Object} numberOfPage - number of the page that is setted into the iframe.
 * @param {Object} frameClassName - type of the page (current, previous or next).
 */
function setIFrameContent(iframeId, nameOfBook, numberOfPage, frameClassName)
{
	//console.log("set iframe content : " + iframeId + " | nameOfBook=" + nameOfBook + " | numberOfPage = " + numberOfPage + " | frameClassName = " + frameClassName + " | pages to load " + pagesToLoad);
	if (numberOfPage > 0 && numberOfPage <= pagesCount)
	{
		//console.log("frame " + iframeId + "init");
		iframeContentLoaded[(numberOfPage - 1) % framesCount] = false;
		
		//if frame source already exist, then clear frame before loading new one
		if(document.getElementById(iframeId).src != "")
			cleanContent(iframeId);
		
		document.getElementById(iframeId).src = pages[numberOfPage - 1];
		document.getElementById(iframeId).onload = function(){
			iframeContentLoaded[(numberOfPage - 1) % framesCount] = true;
			document.getElementById(iframeId).className = frameClassName;
			//console.log("onload iframe content : " + iframeId + " | nameOfBook=" + nameOfBook + " | numberOfPage = " + numberOfPage + " | frameClassName = " + frameClassName);
		}
	}
}
  
/**
 * Cleans the content of the page in iframe with frameId.
 * @param {Object} frameId - id of the frame containing page which content should be cleaned.
 */
function cleanContent(frameId)
{
	//check function for existence before executing it to prevent error
	if(document.getElementById(frameId).contentWindow.cleanPage != null)
		document.getElementById(frameId).contentWindow.cleanPage();
}

/**
 * Make changes for changing current page.
 * @param {Object} pageNumber - number of the new current page.
 */
function setCurrentPage(pageNumber)
{
	if(!deviceChecker.safari)
	{	
		//safari check fails because native application webkit is running reader
		var requestParams = "#pageNumber=" + pageNumber;
		//change window location to send page number as parameter to native application
		parent.window.location = parent.initWindowLocation + requestParams;
	}
	
	//check function for existence before executing it to prevent errors
	if(document.getElementById("frame" + (pageNumber%framesCount)).contentWindow.onCurrentPageSet != null)
		document.getElementById("frame" + (pageNumber%framesCount)).contentWindow.onCurrentPageSet(pageIds[pageNumber], lifeCycleIsPlaying);
		
	localStorage.setItem(bookId, pageNumber);
	
	if(!deviceChecker.android)
	{
		centerPageFrameOnResizeOnDesktopBrowsers();
	}
}
  
/**
 * Setter for state of the book lifecycle.
 * @param {Object} value - new state of the book lifecycle.
 */
function setLifeCycleIsPlaying(value)
{
	lifeCycleIsPlaying = value;
}

/**
 * Retrieves id of the iframe containig current page
 */
function getCurrentPageFrameId()
{
	var result = "frame" + (currentPageNumber%framesCount);
	currentPageFrameId = result;
	return result;
}

/**
 * Retrieves the id of the current page.
 */
function getCurrentPageId()
{
	return pageIds[currentPageNumber];
}

/**
 * Creates book audio element and stores its media info.
 * @param {Object} dataBookAudio - json of the book audio.
 */
function buildBookAudio(dataBookAudio)
{
	var element = document.createElement("audio");
	
	element.setAttribute("id", "bookAudio");
	
	//element.controls = false;
	element.setAttribute('src', dataBookAudio);
	
	//looping now is set manually in play function of media object
	/*			
	if (data.media.looping == "true") {
		element.setAttribute('loop', 'true');
	}
	*/

	element.setAttribute('width', '1px');
	element.setAttribute('height', '1px');
	
	var mediaInfo = tracksSingletonInstance.getMediaInfo("bookAudio");
	if(mediaInfo == null)
	{
		mediaInfo = new Array();
		mediaInfo["start"] = 0;
			
		mediaInfo["end"] = -1; 
	
		mediaInfo["currentTime"] = null;
		
		tracksSingletonInstance.setMediaInfo("bookAudio", mediaInfo);
	}
	
	document.body.appendChild(element);
}

/**
 * Setter for position of the book audio.
 * @param {Object} position - position in milliseconds of the book audio.
 */
function setBookAudioPosition(position)
{
	var track = tracksSingletonInstance.getTrack("bookAudiotrack");
			
	if (track == null) {
		var track = new Track("bookAudio");
		tracksSingletonInstance.setTrack("bookAudiotrack", track);
	}
	
	var	media = document.getElementById("bookAudio");
	
	//check function for existence before executing it po prevent error
	if(frames[getCurrentPageFrameId()].sendPlayMediaViaNativeAppRequest != null)
		frames[getCurrentPageFrameId()].sendPlayMediaViaNativeAppRequest("bookAudio", position);

}

/**
 * Getter for the book audio. Used from pages to iterate with book audio.
 */
function getBookAudio()
{
	if (document.getElementById("bookAudio"))
	{
		var element = document.getElementById("bookAudio");
		return element;
	}
	return null;
}

/**
 * Page with pageId is with setted sources.
 * @param {Object} pageId - id of the page that is built.
 */
function iterationForPageFinished(pageId)
{
	if (pageId == pageIds[currentPageNumber])
	{
		buildThumbnailImages();
		//alert(pageId + " " + currentPageNumber + " " + pageIds[currentPageNumber]);
		preloadAllPagesAround(currentPageNumber, false);
	}
}

/**
 * Setter for position of the page iframe.
 * @param {Object} newLeft - new x position of the iframes with pages.
 * @param {Object} newTop - new y position of the iframes with pages.
 */
function setIFramePosition(newLeft, newTop)
{
	newLeft = (newLeft < 0) ? 0 : newLeft;
	newTop = (newTop < 0 ) ? 0 : newTop;
 	for(var frameIndex = 0; frameIndex < framesCount; frameIndex++)
	{
		document.getElementById("frame" + frameIndex).style.top = newTop;
		document.getElementById("frame" + frameIndex).style.left = newLeft;
	}
	
}

/**
 * Setter for the sizes of the iframes containing pages.
 * @param {Object} newWidth - new width of the iframes with pages.
 * @param {Object} newHeight - new height of the iframes with pages.
 */
function setIFrameSizes(newWidth, newHeight)
{
	for(var frameIndex = 0; frameIndex < framesCount; frameIndex++)
	{
		document.getElementById("frame" + frameIndex).width = newWidth;
		document.getElementById("frame" + frameIndex).height = newHeight;
	}
}

/**
 * Setter for the sizes of the book body.
 * @param {Object} newWidth - new width of the book.
 * @param {Object} newHeight - new height of the book.
 */
function setBodySizes(newWidth, newHeight)
{
	document.body.width = newWidth;
	document.body.height = newHeight;
}

/**
 * Scaling embedded book.
 * @param {Object} newScaleFactorX - scale factor for x.
 * @param {Object} newScaleFactorY - scale factor for y.
 * @param {Object} newBookWidth - new book width.
 * @param {Object} newBookHeight - new book height.
 */
function scaleBook(newScaleFactorX, newScaleFactorY, newBookWidth, newBookHeight)
{
	for(var frameIndex = 0; frameIndex < framesCount; frameIndex++)
	{
		document.getElementById("frame" + frameIndex).width = newBookWidth;
		document.getElementById("frame" + frameIndex).height = newBookHeight;
		document.getElementById("frame" + frameIndex).style.overflow = "hidden";
		if (document.getElementById("frame" + frameIndex).contentWindow &&
			document.getElementById("frame" + frameIndex).contentWindow.scaleEmbeddedPageWithFactor)
			document.getElementById("frame" + frameIndex).contentWindow.scaleEmbeddedPageWithFactor(newScaleFactorX, newScaleFactorY);
	}
	document.body.width = newBookWidth;
	document.body.height = newBookHeight;
}


/**
 * Fits book into the containing window.
 */
function fitBookToScreen()
{
	var oldScaleX = currentBookScaleFactorX;
	var oldScaleY = currentBookScaleFactorY;
	//calculate scale factor
	var scaleW = window.innerWidth / bookWidth;
	var scaleH = window.innerHeight / bookHeight;
	var scaleFactor = Math.min(scaleW, scaleH);
	if (oldScaleX == scaleFactor && oldScaleY == scaleFactor)
		return;

	
	if (scaleFactor > 1) {
		currentBookScaleFactorX = 1;
		currentBookScaleFactorY = 1;
		//do not remember to set currentBookScaleFactorX and currentBookScaleFactorY because they are used in method below that center page		
		centerPageFrameOnResizeOnDesktopBrowsers();
		scaleFactor = 1;
	}
	else{
		currentBookScaleFactorX = scaleFactor;
		currentBookScaleFactorY = scaleFactor;			
	}
	
	for (var frameIndex = 0; frameIndex < framesCount; frameIndex++) {
		if (document.getElementById("frame" + frameIndex).contentWindow && document.getElementById("frame" + frameIndex).contentWindow.scalePageWithFactor) 
			document.getElementById("frame" + frameIndex).contentWindow.scalePageWithFactor(scaleFactor, scaleFactor);
	}
	
}	

  