var errorMessage = "The service is not avaible at the moment,  please try again later. If the problem persists contact ..." 
//url to service that return all comments without posting new one
var getCommentsUrl = "";//"http://localhost:55555/streams/somestream2/"; //comments?author=" + name + "&content=" + comment;
//url to service for posting new comment, on result it returns all comments
var postCommentUrl = "";//getCommentsUrl + "/new";//"http://localhost:55555/streams/somestream2/"; //comments/new?author=" + name + "&content=" + comment;

//dictionary ([id]->[service_url]) used to storing data of comment frames
var commentServices;
//dictionary ([id]->[boolean]), indicate whether service is avaible, to prevent dislpaying of add comment dialog is server is down
var serviceAvaible;
//dictionary ([id]->[scroll_of_element]), used to refresh scroll when comment is added
var commentScrolls;
//used to freeze comment post to prevent multiple submition of one comment
var dialogFreezedForPost = false;

//Create new oval button for comment dialog using sliding doors technic
function createOvalButton(buttonDiv, labelText)
{
	//buttonDiv.className = "buttonwrapper";
	var innerDiv = document.createElement('div');
	innerDiv.className = "ovalbutton";
	var span = document.createElement('span');
	span.innerText = labelText;
	innerDiv.appendChild(span);
	buttonDiv.appendChild(innerDiv);
	//add listeners for changing state of button, do not forget do disable text selection
	buttonDiv.onselectstart = function(){	return false; };  
}

//This function is executed to display comment dialog when "add comment" button is pressed
function showNewCommentDialog(element){
	//prevent dialog from appearing if service is not avaible.
	if(!serviceAvaible[element.id]){
		alert(errorMessage)
		return ;
	}
	//remove event that prevent touch start on body to enable click on textarea for android
	parent.document.removeEventListener('touchstart', preventDefaultOnTouchStartHandler, false);
	
	//clean comment dialog fields when displayed
	var comment = parent.document.getElementById('commentDialog');
	//clean name field
	var commentName = parent.document.getElementById('commentName');
	commentName.value = "";
	checkIfNameIsEmpty(commentName);
	//clean content field
	var commentContent = parent.document.getElementById('commentContent');
	commentContent.value = "";
	checkIfContentIsEmpty(commentContent);
	//make displayable are grey when add commment dialog is shown
	var shade = parent.document.getElementById('commentShade');
	
	var submitButton = parent.document.getElementById('commentSubmit');
	var cancelButton = parent.document.getElementById('commentCancel');
	
	comment.style.display = shade.style.display ='block';
	//do not forget to center dialog when shown 
	centerAddCommentDialog();
	
	if (deviceChecker.android || deviceChecker.iphone) {
		//we are running on android or ipad
		submitButton.addEventListener("touchend", postHandler = function(event){
			postComment(element);
			event.preventDefault();
		}, false);
		cancelButton.addEventListener("touchend", closeHandler = function(event){
			closeCommentDialog(element);
			event.preventDefault();
		}, false);
	}
	else {//on PC
		commentName.focus();
		submitButton.onclick = function(){
			postComment(element);
		}
		cancelButton.onclick = function(){
			closeCommentDialog(element);
		}
	}
}

/**
 * Generate add comment button for comment frame.
 * Note that event listener are added when button is pressed because we have single comment dialog box for whole book and many comment frames.
 */
function createAddCommentButton(element){
	
	var showCommentDialogButton = document.createElement('div');
	createOvalButton(showCommentDialogButton, "add comment");
	
	//note it's important to add click handlers of submit dialog after dialog is displayed because we use single dialog for whole book
	//it's necessary because we must know for which comment frame we are submiting comment
	if(deviceChecker.android || deviceChecker.iphone)
	{
		showCommentDialogButton.addEventListener("touchend", 
			function(event){
				showNewCommentDialog(element);
			}
		);
	}
	else//PC
	{
		showCommentDialogButton.onclick = function(){
			showNewCommentDialog(element);
		}
	}
	return showCommentDialogButton;
}

/**
 * create button used to send refresh request to the comment service
 * and display response in the comment frame
 */
function createRefreshCommentsButton(element){
	
	var refreshButton = document.createElement('div');
	createOvalButton(refreshButton, "refresh");
	refreshButton.className = "buttonRefreshComments";
	
	//add click listener for different devices
	if(deviceChecker.android || deviceChecker.iphone)
	{
		refreshButton.addEventListener("touchend", 
			function(event){
				getAllComments(element)
			}
		);
	}
	else//PC
	{
		refreshButton.onclick = function(){
			getAllComments(element);
		}
	}	
	return refreshButton;
}

/**
 * Creates inner comment for an comment sophie frame
 * @param {Object} data - json of the sophie frame
 * @return - div element for the comment frame
 */
function buildCommentInnerElement(data){
	
	if(commentServices == null)
	{
		commentServices = new Array();
		console.log("Init comment services. commentServices = new Array()");
	}
	if(serviceAvaible == null)
	{
		serviceAvaible = new Array();
	}
	if(commentScrolls == null)
	{
		commentScrolls = new Array();
	}
	var element = document.createElement('div');
	element.setAttribute("id", data.id);
	//add service url and availability to dictionaries
	//add comments to service url
	var serviceUrl = data.comment.service;
	//add back splash if not specified by user 
	serviceUrl += (serviceUrl[serviceUrl.length-1] != '/') ? "/" : "";
	//add comments postfix
	serviceUrl += "comments"
	commentServices[data.id] = new String(serviceUrl);
	serviceAvaible[data.id] = false;
	
	var commentStyle = getContentStyle(data);
	element.setAttribute('style', commentStyle);
	
	//comment frame element has two divs for header part with comments and footer part with adding comment
	element.innerHTML = '<div id="' + data.id + 'wrapper" style="position:relative; height:' + (data.height - 26) +'px; overflow: auto;">' +
						'	<div id="' + data.id + 'scroller" style="position:relative;"></div>' +
						'</div>' +
						'<div style="width: 100%; position: absolute; bottom: 0px; left: 0px; height:26;"> </div>'
	//here we get all comments and put them in first child of element
	getAllComments(element);
	//here we append add comment button at the bottom div
	element.children[1].appendChild(createAddCommentButton(element));
	var spacer = document.createElement('div');
	spacer.className = "spacer";
	element.children[1].appendChild(spacer);
	element.children[1].appendChild(createRefreshCommentsButton(element));
	return element;
}

/**
 * Get all comments when comment frame is build.
 */
function getAllComments(element)
{	
	//here we send request and get response in json format
	var jqxhrResponse = $.getJSON(commentServices[element.id] + "?callback=?",
		function(data) {
			//success handler		
			serviceAvaible[element.id] = true;
			//parse response to HTML
			parseResponseFromServiceAndBuildHTML(element, data);
		})
		.error(function(){
			serviceAvaible[element.id] = false;
			element.children[0].innerHTML = '<span style="font-family:Monospace; font-size:12;"> ' + errorMessage + '</span><br>';
		});
}
/**
 * Method used to parse response from service, build html data and return it as string
 */

function parseResponseFromServiceAndBuildHTML(element, data)
{
	var responseHTML = "";
	
	for(var i=0; i<data.length; i++)
	{
		responseHTML += '<span style="font-family:Monospace; font-size:12;">';
		responseHTML += '[ <span style="color:rgb(45,45,45);"><i>' + data[i].author + ' ' + data[i].date + '</i></span> ]: ';
		responseHTML += data[i].content + '</span><br>';
	}
	
	element.children[0].children[0].innerHTML = responseHTML;
	//add iScroll after comments are added to frame or just refresh it if it's already added
	if(commentScrolls[element.id] == null)
	{
		commentScrolls[element.id] = new iScroll(element.children[0]);
	}
	else
	{
		commentScrolls[element.id].refresh();
	}
}

/**
 * Used to post debug messages for andoird devices because no console is avaible on these devices yet
 */
function postDebugMessage(message){
	//message is posted to all comments frames
	for(var name in commentServices)
	{
		console.log("commentServices[name] = " + commentServices[name] + " | message = " + message);
		var url = commentServices[name] + "/new?author=DEBUG&content=" + message;
		$.getJSON(url);
	}
}
/**
 * Method used to post comment, after comment is posted we refresh comment frame with response from the service.
 * @param {Object} element - comment frame which content will be updated after comment is posted
 */
function postComment(element)
{
	if(dialogFreezedForPost){
		//do nothing, wait for service response
		return ;
	}
		
	var commentName = parent.document.getElementById('commentName');
	var commentContent = parent.document.getElementById('commentContent');
	var url = commentServices[element.id] + "/new?author=" + commentName.value + "&content=" + commentContent.value;
	//do not post empty comments
	if(commentName.value == "" || commentName.style.color != "rgb(0, 0, 0)")
	{
		$("#commentName").focus();	
		return;
	}
	if(commentContent.value == "" || commentContent.style.color != "rgb(0, 0, 0)")
	{
		$("#commentContent").focus();	
		return;
	}

	dialogFreezedForPost = true;
	//Below we send request and get response in json format
	// Assign handlers immediately after making the request,
	// and remember the jqxhr object for this request
	var jqxhrResponse = $.getJSON(url+ "&callback=?", 
		function(data) {
			//parse response from service
			parseResponseFromServiceAndBuildHTML(element, data);
			dialogFreezedForPost = false;
			closeCommentDialog(element);			
		})
		.error(function(){
			dialogFreezedForPost = false; 
			alert("service is not avaible, please try again later");
			closeCommentDialog(element);
		});
	
}

/**
 * Close comment dialog and clear it fields, also remove submit and close event listeners because of issues on iOS and Android.
 * Executed on cancel button pressed or after comment is posted.
 */
function closeCommentDialog(element) { 
	
	if(dialogFreezedForPost){
		//do nothing, service request is pending, wait for response
		return ;
	}
	var comment = parent.document.getElementById('commentDialog');
	//var modal = parent.document.getElementById('commentModal');
	var shade = parent.document.getElementById('commentShade');
	
	comment.style.display = 'none';
	//modal.style.display=
	shade.style.display = 'none'; 
	
	
	//do not forget to remove event listeners
	var submitButton = parent.document.getElementById('commentSubmit');
	var cancelButton = parent.document.getElementById('commentCancel');
	//remove click listener for different devices
	if (deviceChecker.android || deviceChecker.iphone) {
		//we are running on android or ipad
		submitButton.removeEventListener("touchend", postHandler, false);
		cancelButton.removeEventListener("touchend", closeHandler, false);
	}
	else {//on PC
		submitButton.onclick = null;
		cancelButton.onclick = null;
	}
	
	//here we clear content
	var name = parent.document.getElementById('commentName');
	var content = parent.document.getElementById('commentContent');
	name.value = content.value = "";
	//add event that prevent touch start on body to enable iscroll 
	parent.document.addEventListener('touchstart', preventDefaultOnTouchStartHandler, false);
}


//help functions for comment dialog pop up are defined below
//when name input is focused we must change text color to black
function focusNameInput(inputArea)
{
	if(inputArea.style.color != "rgb(0, 0, 0)")
	{
		inputArea.value = "";
		inputArea.style.color = "#000000";
	}
}

//check whether comment name is empty to restore initial grey text
function checkIfNameIsEmpty(inputArea)
{
	if(inputArea.value == "")
	{
		inputArea.value = "Enter Name";
		inputArea.style.color = "#b3b3b3";
	}
}

//when content input is focused we must change text color to black
function focusCommentInput(inputArea)
{
	if(inputArea.style.color != "rgb(0, 0, 0)")
	{
		inputArea.value = "";
		inputArea.style.color = "#000000";
	}
}

//check whether comment content is empty to restore intial grey text
function checkIfContentIsEmpty(inputArea)
{
	if(inputArea.value == "")
	{
		inputArea.value = "Add Comment";
		inputArea.style.color = "#b3b3b3";
	}
}