//function that check if iframe contain page, because we use iframe object for browser frame too
function checkIfIsPageIframe(frameId)
{
	if(document.getElementById(frameId).contentWindow != undefined && 
		document.getElementById(frameId).contentWindow.onFirstPageLoaded != undefined)
		return true;
	return false;
}
/**
 * Cleaning cache of videos and audios on the page when page is unloaded
 */
function cleanPage()
{
	var i;
	
	//build links triggers
	//console.log("pageData.links = " + pageData.links);
	
	//check whether pageData is undefined because of issues with fast navigation through pages	
    if (typeof(pageData) !== "undefined" && pageData.links != null) {
        //remove event listeners for link data
        for (var i = 0; i < pageData.links.length; i++) {
            //map of functions is used to set links
            eventsDict[pageData.links[i].event](pageData.links[i].source, pageData.links[i].target, pageData.links[i].action, pageData.links[i].property, false);
        }
    }

	var frameTags = document.getElementsByTagName("iframe");
	var frameElement;
	for (i=0; i<frameTags.length; i++)
	{
		frameElement = document.getElementById(frameTags[i].id);
		if (checkIfIsPageIframe(frameTags[i].id)) {
			var curFrame = frameElement.contentWindow.getCurrentPageFrameId();
			frameElement.contentWindow.document.getElementById(curFrame).contentWindow.cleanPage();
		}
		else{
			//iframe is used for browser frame or page frame in both cases remove event listeners
			//frameElement.removeEventListener('touchstart');
			//frameElement.removeEventListener('touchmove');
		}
	}

	var videoTags = document.getElementsByTagName("video");
	var videoElement;
	for (i=0; i<videoTags.length; i++)
	{
		videoElement = document.getElementById(videoTags[i].id)
		if(videoElement.paused != undefined && !videoElement.paused)
			videoElement.pause();
		videoElement.src = "";
		getTracksSingleton().removeTrack(videoTags[i].id+"track");
	}
	var audioTags = document.getElementsByTagName("audio");
	var audioElement;
	for (i=0; i<audioTags.length; i++)
	{
		audioElement = document.getElementById(audioTags[i].id);
		if(audioElement.paused != undefined && !audioElement.paused)
			audioElement.pause();
		audioElement.src = "";
		getTracksSingleton().removeTrack(audioTags[i].id+"track");
	}
	var imageTags = document.getElementsByTagName("img");
	var imageElement;
	for (i=0; i<imageTags.length; i++)
	{
		imageElement = document.getElementById(imageTags[i].id);
		imageElement.src = "";
	}
	console.log("clean page");
	
	//when we are swiping too fast some body of iframe can not be initialized 
	if (document.body != null) {
		var bodyChilds = document.body.children;
		for (i = 0; i < bodyChilds.length; i++) 
			document.body.removeChild(bodyChilds[i]);
	}
}

/**
 * When page is shown rewind timeline of all frames
 */
function onCurrentPageSet(currentPageId, lifeCycleIsPlaying){
	
	var iframeTags = document.getElementsByTagName("iframe");
	for (i = 0; i < iframeTags.length; i++) {
		if (checkIfIsPageIframe(iframeTags[i].id)) {
			if (document.getElementById(iframeTags[i].id).contentWindow.currentPageNumber == 0)
				document.getElementById(iframeTags[i].id).contentWindow.onFirstPageLoaded(event);
			else {
				document.getElementById(iframeTags[i].id).contentWindow.goToPage(1);
			}
		}
	}
	
	if (lifeCycleIsPlaying) {
		parent.startLifeCycle("pageLifeCycle", currentPageId);
		
		//check variable for existence
		//if (typeof(bookAudioPosition) !== "undefined" && bookAudioPosition != -1) {
		//	parent.setBookAudioPosition(bookAudioPosition);
		//}
	}
	
	var event = document.createEvent("Event");
	event.initEvent("PAGE_SHOWN", true, true);
	window.dispatchEvent(event);
	
	/*
	if (db != null) 
		loadedDatabase();
	*/
}

/**
 * When page is hidden, pausing all videos and audios and stop timelines of each sophie frames
 */
function onNotCurrentPage(page)
{
	var i;
	
	var frameTags = document.getElementsByTagName("iframe");
	var frameElement;
	for (i = 0; i < frameTags.length; i++) {
		var frameElement = document.getElementById(frameTags[i].id)
		if (frameElement.contentWindow != undefined) {
			var curFrame = frameElement.contentWindow.getCurrentPageFrameId();
			var curPageId = frameElement.contentWindow.getCurrentPageId();
			frameElement.contentWindow.document.getElementById(curFrame).contentWindow.onNotCurrentPage(curPageId);
		}
	}	
	var audioTags = document.getElementsByTagName("audio");
	var audioElement;
	for (i=0; i<audioTags.length; i++)
	{
		var element = window.frames[audioTags[0].id];
		
		audioElement = document.getElementById(audioTags[i].id)
		if (audioElement.paused != undefined && !audioElement.paused) {
			audioElement.pause();
		}
		if(document.getElementById("pauseButton" + audioTags[i].id))
		{
			document.getElementById("playButton"+audioTags[i].id).setAttribute("style", "display: inline;");
			document.getElementById("pauseButton"+audioTags[i].id).setAttribute("style", "display: none;");
		}
	}
	
	var videoTags = document.getElementsByTagName("video");
	var videoElement;
	for (i=0; i<videoTags.length; i++)
	{
		videoElement = document.getElementById(videoTags[i].id)
		if(videoElement.paused != undefined && !videoElement.paused)
			videoElement.pause();
		if(document.getElementById("pauseButton" + videoTags[i].id))
		{
			document.getElementById("playButton"+videoTags[i].id).setAttribute("style", "display: inline;");
			document.getElementById("pauseButton"+videoTags[i].id).setAttribute("style", "display: none;");
		}
		//videoElement.currentTime = 0;
	}
	
	parent.stopLifeCycle("pageLifeCycle", page);

	var event = document.createEvent("Event");
    event.initEvent("PAGE_HIDDEN", true, true);
    window.dispatchEvent(event);
}

function goToOtroOfPage(toNextPage)
{
	if (toNextPage)
		goToNextPageAfterOutro = true;
	else
		goToPreviousPageAfterOutro = true;
	goTo("pageLifeCycle", {
		"phase": "OUTRO",
		"milliseconds": 0
	});
	//stopPageAudio();        
}
