var TracksSingleton = (function() {
    var instance = null;

    function PrivateConstructor() {
		
		var tracks = new Array();
		var mediaInfo = new Array(); // contains start, end and currentTime time for every media
		
		var rand = Math.round(Math.random() * 100);
        var currentPlaying = null;
		
		this.getRand = function() {
			return rand;
        }
		
		this.addTrack = function(data)
		{
			console.log("addTrack");
		}
		
		
		this.setCurrentPlayingMedia = function(mediaId)
		{
			currentPlaying = mediaId
		}
		
		this.getCurrentPlayingMedia = function()
		{
			return currentPlaying;
		}
		
		this.setMediaInfo = function(mediaId, info)
		{
			//console.log("media info for media with id " + mediaId + " created");
			mediaInfo[mediaId] = info;
		}
		
		//get media info for specified media
		this.getMediaInfo = function(mediaId)
		{
			return mediaInfo[mediaId];
		}
		
		//set track with specified track id
		this.setTrack = function(trackId, track)
		{
			//console.log("track for track with id " + trackId + " created");
			tracks[trackId] = track;
		}
		
		//get track by given track id
		this.getTrack = function(trackId) {
			return tracks[trackId];
		}
		
		this.removeTrack = function(trackId) {
			tracks[trackId] = null;
		}
		
    }

    return new function() {
        this.getInstance = function() {
            if (instance == null) {
                console.log("TracksSingleton instance is null, exec private constructor");
				instance = new PrivateConstructor();
                instance.constructor = null;
            }
            return instance;
        }
    }
})();
